/***********************************************************
 * $Id$
 *
 * FancyLibs
 *
 * Copyright (C) 2009-2011 ev-i GmbH & IBCL e.U.
 * Copyright (C) 2011-2013 ITEG IT-Engineers GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ************************************************************/

/****************************************************************************
**
** Author: Wolfgang Glas / EV-i
**
** Global exception class stuff.
** 
*****************************************************************************/

#ifndef FANCYSOCK_EXCEPTION_H
#define FANCYSOCK_EXCEPTION_H

#include <fancyexception.h>
#include <fancysock.h>

namespace Fancy {
  namespace Sock {
    class FANCYSOCK_API Exception : public Fancy::Exception
    { 
    public:
      Exception (int facility,
                 int priority,
                 const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
        ;

      ~Exception() throw ();

    protected:
      Exception (fancylog_service *service,
                 int facility,
                 int priority) throw();
    };

    class FANCYSOCK_API CException : public Fancy::CException
    { 
    public:
      CException (int facility,
                  int priority,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,4,5)))
#endif
        ;

      CException (int facility,
                  int priority,
                  int _err,
                  const char *fmt, ...) throw()
#ifdef __GNUG__
        __attribute__((format(printf,5,6)))
#endif
        ;

      ~CException() throw();
    };

  }
}

#endif // ! FANCYSOCK_LOG_H
